package ch.zhaw.ads;

public class MySortedList extends MyList {

    @Override
    public boolean add(Object o) {
        if (!(o instanceof Comparable)) {
            throw new IllegalArgumentException("Object is not comparable!");
        }
        if (head == null) {
            head = new MyNode(null, null, o);
            tail = head;
        } else {
            Comparable newData = (Comparable)o;
            MyNode actual_Node = head;
            while(newData.compareTo(actual_Node.getData()) > 0){
                if(actual_Node.getNextNode() != null){
                    actual_Node = actual_Node.getNextNode();
                } else {
                    //insert after actual
                    MyNode newNode = new MyNode(null, actual_Node, o);
                    actual_Node.setNextNode(newNode);
                    tail = newNode;
                    return true;
                }
            }
            //insert before actual
            MyNode newNode = new MyNode(actual_Node, actual_Node.getPreviousNode(), o);
            if(actual_Node.getPreviousNode() != null) {
                actual_Node.getPreviousNode().setNextNode(newNode);
            }
            actual_Node.setPreviousNode(newNode);
            if(actual_Node == head)
            {
                head = newNode;
            }
        }
        return true;
    }


}
